"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextField = void 0;
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _styledComponents = /*#__PURE__*/require("@salutejs/plasma-new-hope/styled-components");
var _TextField = /*#__PURE__*/require("./TextField.config");
var _excluded = ["view", "status", "label", "caption", "placeholder", "helperText", "enumerationType", "chips", "onSearch", "onChangeChips"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var mergedConfig = /*#__PURE__*/(0, _styledComponents.mergeConfig)(_styledComponents.textFieldConfig, _TextField.config);
var TextFieldComponent = /*#__PURE__*/(0, _styledComponents.component)(mergedConfig);
var statusToView = {
  success: 'positive',
  warning: 'warning',
  error: 'negative'
};
var viewToLabelPlacement = {
  "default": 'outer',
  innerLabel: 'inner'
};

/**
 * Поле ввода текста.
 */
var TextField = exports.TextField = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var view = props.view,
    status = props.status,
    label = props.label,
    caption = props.caption,
    placeholder = props.placeholder,
    helperText = props.helperText,
    enumerationType = props.enumerationType,
    chips = props.chips,
    onSearch = props.onSearch,
    onChangeChips = props.onChangeChips,
    rest = _objectWithoutProperties(props, _excluded);

  /** TODO: https://github.com/salute-developers/plasma/issues/1064 Remove In plasma-2.0 */
  /* eslint-disable no-underscore-dangle */
  var _view = status ? statusToView[status] : 'default';
  var _labelPlacement = view ? viewToLabelPlacement[view] : 'outer';
  var _label = label ? String(label) : caption;
  var _placeholder = placeholder;
  // NOTE: rest.size https://github.com/salute-developers/plasma/issues/961
  // if size is undefined <TextFieldComp size={size} /> would not use defaults
  if (rest.size === 'xs' && _labelPlacement === 'inner') {
    _placeholder = _label;
    _label = undefined;
    _labelPlacement = 'outer';
  }
  if (enumerationType === 'chip') {
    return /*#__PURE__*/_react["default"].createElement(TextFieldComponent, _extends({}, rest, {
      view: _view,
      labelPlacement: _labelPlacement,
      label: _label,
      placeholder: _placeholder,
      leftHelper: helperText,
      ref: ref,
      enumerationType: "chip",
      chips: chips,
      onChangeChips: onChangeChips
    }));
  }
  return /*#__PURE__*/_react["default"].createElement(TextFieldComponent, _extends({}, rest, {
    view: _view,
    labelPlacement: _labelPlacement,
    label: _label,
    placeholder: _placeholder,
    leftHelper: helperText,
    ref: ref,
    enumerationType: "plain",
    onSearch: onSearch
  }));
});