'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../../../_virtual/_rollupPluginBabelHelpers.js');
var React = require('react');
var DropdownUncontrolled = require('./DropdownUncontrolled.js');

var _excluded = ["closeOnSelect", "onToggle", "onItemClick", "onItemSelect"];
var Dropdown = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$closeOnSelect = _ref.closeOnSelect,
    closeOnSelect = _ref$closeOnSelect === void 0 ? true : _ref$closeOnSelect,
    onToggle = _ref.onToggle,
    onItemClick = _ref.onItemClick,
    onItemSelect = _ref.onItemSelect,
    rest = _rollupPluginBabelHelpers.objectWithoutProperties(_ref, _excluded);
  var _useState = React.useState(false),
    _useState2 = _rollupPluginBabelHelpers.slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var handleToggle = function handleToggle(currentState, event) {
    setIsOpen(currentState);
    if (onToggle) {
      onToggle(currentState, event);
    }
  };
  var handleClick = function handleClick(item, event) {
    if (onItemClick) {
      onItemClick(item, event);
    }
    if (onItemSelect) {
      onItemSelect(item, event);
    }
    if (closeOnSelect) {
      setIsOpen(false);
    }
  };
  return /*#__PURE__*/React.createElement(DropdownUncontrolled.DropdownUncontrolled, _rollupPluginBabelHelpers.extends({}, rest, {
    ref: ref,
    isOpen: isOpen,
    onToggle: handleToggle,
    closeOnSelect: closeOnSelect,
    handleClick: handleClick,
    onGlobalClose: function onGlobalClose() {
      return setIsOpen(false);
    }
  }));
});

exports.Dropdown = Dropdown;
//# sourceMappingURL=Dropdown.js.map
